#!/usr/bin/env python3

"""
based on code from Nick Parlante for Stanford CS106A
"""

from utilities import draw_grid_canvas, start_timer, SIDE

import sys
import random
import drawcanvas
import tkinter

from byugrid import Grid


def random_right(grid):
    """
    Set 10% of the right grid column to random letters from the word 'cougars'
    :param grid: a grid
    :return: the same grid, but with random letters on the right edge
    >>> grid1 = Grid.build([[None ], [None], [None], [None], [None], [None], [None], [None], [None], [None]])
    >>> random.seed(86)
    >>> random_right(grid1)
    [['a'], [None], ['s'], [None], [None], [None], [None], [None], [None], [None]]
    """
    pass


def scroll_left(grid):
    """
    Implement scroll_left as in lecture notes.
    >>> grid1 = Grid.build([['a', 'b', 'c'], ['d', None, None]])
    >>> scroll_left(grid1)
    [['b', 'c', None], [None, None, None]]
    """
    pass


# ************* Utility Functions Below here

def movie_action(grid, canvas):
    """Do one round of the move, call in timer."""
    random_right(grid)
    draw_grid_canvas(grid, canvas)
    scroll_left(grid)


def main():
    args = sys.argv[1:]

    width = 30
    height = 30

    # Can give width/height on command line
    if len(args) == 2:
        width = int(args[0])
        height = int(args[1])

    # create the grid
    grid = Grid(width, height)

    # draw the canvas
    canvas = drawcanvas.make_canvas(width * SIDE, height * SIDE, 'Movie')
    draw_grid_canvas(grid, canvas)

    # start a timer that will call movie_action every 30ms
    start_timer(canvas, 30, lambda: movie_action(grid, canvas))

    # run the animation
    tkinter.mainloop()


if __name__ == '__main__':
    main()
